'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.decode = exports.encode = exports.detectIfId = exports.decodeId = exports.encodeId = undefined;

var _hashids = require('hashids');

var _hashids2 = _interopRequireDefault(_hashids);

var _flat = require('flat');

var _flat2 = _interopRequireDefault(_flat);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var hashid = new _hashids2.default('', 5);

var encodeId = exports.encodeId = function encodeId(id) {
  return hashid.encode(id);
};

var decodeId = exports.decodeId = function decodeId(id) {
  return hashid.decode(id)[0];
};

var detectIfId = exports.detectIfId = function detectIfId() {
  var string = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

  return (/(([a-z]+)_)?id(\W|$)/.test(string.toLowerCase())
  );
};

var encode = exports.encode = function encode() {
  var origin = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var response = {};

  origin = (0, _flat2.default)(origin);

  for (var prop in origin) {
    if (detectIfId(prop)) {
      response[prop] = encodeId(origin[prop]);
    } else {
      response[prop] = origin[prop];
    }
  }

  return (0, _flat.unflatten)(response);
};

var decode = exports.decode = function decode() {
  var origin = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var response = {};

  origin = (0, _flat2.default)(origin);

  for (var prop in origin) {
    if (detectIfId(prop) && typeof origin[prop] === 'string') {
      response[prop] = decodeId(origin[prop]);
    } else {
      response[prop] = origin[prop];
    }
  }

  return (0, _flat.unflatten)(response);
};

exports.default = { encodeId: encodeId, decodeId: decodeId, detectIfId: detectIfId, encode: encode, decode: decode };